Index: uspace/drv/bus/usb/usbmid/main.c
===================================================================
--- uspace/drv/bus/usb/usbmid/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/usbmid/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -51,7 +51,28 @@
 static errno_t usbmid_device_add(usb_device_t *dev)
 {
-	usb_log_info("Taking care of new MID `%s'.\n", usb_device_get_name(dev));
+	usb_log_info("Taking care of new MID `%s'.", usb_device_get_name(dev));
 
 	return usbmid_explore_device(dev);
+}
+
+static int destroy_interfaces(usb_mid_t *usb_mid)
+{
+	int ret = EOK;
+
+	while (!list_empty(&usb_mid->interface_list)) {
+		link_t *item = list_first(&usb_mid->interface_list);
+		list_remove(item);
+
+		usbmid_interface_t *iface = usbmid_interface_from_link(item);
+
+		const int pret = usbmid_interface_destroy(iface);
+		if (pret != EOK) {
+			usb_log_error("Failed to remove child `%s': %s",
+			    ddf_fun_get_name(iface->fun), str_error(pret));
+			ret = pret;
+		}
+	}
+
+	return ret;
 }
 
@@ -70,5 +91,5 @@
 	errno_t ret = ddf_fun_unbind(usb_mid->ctl_fun);
 	if (ret != EOK) {
-		usb_log_error("Failed to unbind USB MID ctl function: %s.\n",
+		usb_log_error("Failed to unbind USB MID ctl function: %s.",
 		    str_error(ret));
 		return ret;
@@ -77,30 +98,17 @@
 
 	/* Remove all children */
-	while (!list_empty(&usb_mid->interface_list)) {
-		link_t *item = list_first(&usb_mid->interface_list);
-		list_remove(item);
-
-		usbmid_interface_t *iface = usbmid_interface_from_link(item);
-
-		usb_log_info("Removing child `%s'.\n",
+	list_foreach(usb_mid->interface_list, link, usbmid_interface_t, iface) {
+		usb_log_info("Removing child `%s'.",
 		    ddf_fun_get_name(iface->fun));
 
-		/* Tell the child to go off-line. */
+		/* Tell the child to go offline. */
 		errno_t pret = ddf_fun_offline(iface->fun);
 		if (pret != EOK) {
-			usb_log_warning("Failed to turn off child `%s': %s\n",
+			usb_log_warning("Failed to turn off child `%s': %s",
 			    ddf_fun_get_name(iface->fun), str_error(pret));
-			ret = pret;
-		}
-
-		/* Now remove the child. */
-		pret = usbmid_interface_destroy(iface);
-		if (pret != EOK) {
-			usb_log_error("Failed to destroy child `%s': %s\n",
-			    ddf_fun_get_name(iface->fun), str_error(pret));
-			ret = pret;
 		}
 	}
-	return ret;
+
+	return destroy_interfaces(usb_mid);
 }
 
@@ -116,10 +124,10 @@
 	assert(usb_mid);
 
-	usb_log_info("USB MID gone: `%s'.\n", usb_device_get_name(dev));
+	usb_log_info("USB MID gone: `%s'.", usb_device_get_name(dev));
 
 	/* Remove ctl function */
 	errno_t ret = ddf_fun_unbind(usb_mid->ctl_fun);
 	if (ret != EOK) {
-		usb_log_error("Failed to unbind USB MID ctl function: %s.\n",
+		usb_log_error("Failed to unbind USB MID ctl function: %s.",
 		    str_error(ret));
 		return ret;
@@ -127,22 +135,26 @@
 	ddf_fun_destroy(usb_mid->ctl_fun);
 
-	/* Now remove all other functions */
-	while (!list_empty(&usb_mid->interface_list)) {
-		link_t *item = list_first(&usb_mid->interface_list);
-		list_remove(item);
+	/* Destroy children and tell their drivers they are gone. */
+	return destroy_interfaces(usb_mid);
+}
 
-		usbmid_interface_t *iface = usbmid_interface_from_link(item);
+static int usbmid_function_online(ddf_fun_t *fun)
+{
+	usb_device_t *usb_dev = ddf_dev_data_get(ddf_fun_get_dev(fun));
+	usb_mid_t *usb_mid = usb_device_data_get(usb_dev);
+	if (fun == usb_mid->ctl_fun)
+		return ENOTSUP;
 
-		usb_log_info("Child `%s' is gone.\n",
-		    ddf_fun_get_name(iface->fun));
+	return ddf_fun_online(fun);
+}
 
-		const errno_t pret = usbmid_interface_destroy(iface);
-		if (pret != EOK) {
-			usb_log_error("Failed to remove child `%s': %s\n",
-			    ddf_fun_get_name(iface->fun), str_error(pret));
-			ret = pret;
-		}
-	}
-	return ret;
+static errno_t usbmid_function_offline(ddf_fun_t *fun)
+{
+	usb_device_t *usb_dev = ddf_dev_data_get(ddf_fun_get_dev(fun));
+	usb_mid_t *usb_mid = usb_device_data_get(usb_dev);
+	if (fun == usb_mid->ctl_fun)
+		return ENOTSUP;
+
+	return ddf_fun_offline(fun);
 }
 
@@ -150,6 +162,8 @@
 static const usb_driver_ops_t mid_driver_ops = {
 	.device_add = usbmid_device_add,
-	.device_rem = usbmid_device_remove,
+	.device_remove = usbmid_device_remove,
 	.device_gone = usbmid_device_gone,
+	.function_online = usbmid_function_online,
+	.function_offline = usbmid_function_offline
 };
 
Index: uspace/drv/bus/usb/usbmid/usbmid.c
===================================================================
--- uspace/drv/bus/usb/usbmid/usbmid.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/usbmid/usbmid.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -45,27 +45,31 @@
 #include "usbmid.h"
 
-/** Get USB device handle by calling the parent usb_device_t.
+/**
+ * Get USB device description by calling HC and altering the interface field.
  *
  * @param[in] fun Device function the operation is running on.
- * @param[out] handle Device handle.
+ * @param[out] desc Device descriptor.
  * @return Error code.
  */
-static errno_t usb_iface_device_handle(ddf_fun_t *fun, devman_handle_t *handle)
-{
-	assert(fun);
-	assert(handle);
-	usb_device_t *usb_dev = usb_device_get(ddf_fun_get_dev(fun));
-	*handle = usb_device_get_devman_handle(usb_dev);
-	return EOK;
-}
-
-/** Callback for DDF USB get interface. */
-static errno_t usb_iface_iface_no(ddf_fun_t *fun, int *iface_no)
+static errno_t usb_iface_description(ddf_fun_t *fun, usb_device_desc_t *desc)
 {
 	usbmid_interface_t *iface = ddf_fun_data_get(fun);
 	assert(iface);
+	usb_device_t *usb_dev = ddf_dev_data_get(ddf_fun_get_dev(fun));
+	assert(usb_dev);
 
-	if (iface_no)
-		*iface_no = iface->interface_no;
+	async_exch_t *exch = usb_device_bus_exchange_begin(usb_dev);
+	if (!exch)
+		return EPARTY;
+
+	usb_device_desc_t tmp_desc;
+	const errno_t ret = usb_get_my_description(exch, &tmp_desc);
+
+	if (ret == EOK && desc) {
+		*desc = tmp_desc;
+		desc->iface = iface->interface_no;
+	}
+
+	usb_device_bus_exchange_end(exch);
 
 	return EOK;
@@ -74,6 +78,5 @@
 /** DDF interface of the child - USB functions. */
 static usb_iface_t child_usb_iface = {
-	.get_my_device_handle = usb_iface_device_handle,
-	.get_my_interface = usb_iface_iface_no,
+	.get_my_description = usb_iface_description,
 };
 
Index: uspace/drv/bus/usb/vhc/conndev.c
===================================================================
--- uspace/drv/bus/usb/vhc/conndev.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/vhc/conndev.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -113,5 +113,5 @@
 		receive_device_name(callback);
 		
-		usb_log_info("New virtual device `%s' (id: %" PRIxn ").\n",
+		usb_log_info("New virtual device `%s' (id: %" PRIxn ").",
 		    plugged_device_name, plugged_device_handle);
 	} else
@@ -130,5 +130,5 @@
 
 	if (plugged_device_handle != 0) {
-		usb_log_info("Virtual device `%s' disconnected (id: %" PRIxn ").\n",
+		usb_log_info("Virtual device `%s' disconnected (id: %" PRIxn ").",
 		    plugged_device_name, plugged_device_handle);
 		vhc_virtdev_unplug(vhc, plugged_device_handle);
Index: uspace/drv/bus/usb/vhc/hub/hub.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub/hub.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/vhc/hub/hub.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -231,5 +231,5 @@
 	}
 
-	usb_log_debug("Setting port %zu to state %d.\n", port_index, state);
+	usb_log_debug("Setting port %zu to state %d.", port_index, state);
 
 	switch (state) {
@@ -423,5 +423,5 @@
 	uint16_t old_value = port->status_change;
 	port->status_change |= change;
-	usb_log_debug("Changing status change on %zu: %04x => %04x\n",
+	usb_log_debug("Changing status change on %zu: %04x => %04x",
 	    port->index,
 	    (unsigned int) old_value, (unsigned int) port->status_change);
@@ -510,5 +510,5 @@
 	fid_t fibril = fibril_create(set_port_state_delayed_fibril, change);
 	if (fibril == 0) {
-		printf("Failed to create fibril\n");
+		usb_log_error("Failed to create fibril.");
 		free(change);
 		return;
Index: uspace/drv/bus/usb/vhc/hub/virthubops.c
===================================================================
--- uspace/drv/bus/usb/vhc/hub/virthubops.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/vhc/hub/virthubops.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -137,5 +137,5 @@
 
 	switch (feature) {
-		case USB_HUB_FEATURE_PORT_ENABLE:
+		case USB2_HUB_FEATURE_PORT_ENABLE:
 			if ((port_state != HUB_PORT_STATE_NOT_CONFIGURED)
 			    && (port_state != HUB_PORT_STATE_POWERED_OFF)) {
@@ -145,5 +145,5 @@
 			break;
 
-		case USB_HUB_FEATURE_PORT_SUSPEND:
+		case USB2_HUB_FEATURE_PORT_SUSPEND:
 			if (port_state != HUB_PORT_STATE_SUSPENDED) {
 				rc = EOK;
@@ -166,10 +166,10 @@
 			break;
 
-		case USB_HUB_FEATURE_C_PORT_ENABLE:
+		case USB2_HUB_FEATURE_C_PORT_ENABLE:
 			hub_clear_port_status_change(hub, port, HUB_STATUS_C_PORT_ENABLE);
 			rc = EOK;
 			break;
 
-		case USB_HUB_FEATURE_C_PORT_SUSPEND:
+		case USB2_HUB_FEATURE_C_PORT_SUSPEND:
 			hub_clear_port_status_change(hub, port, HUB_STATUS_C_PORT_SUSPEND);
 			rc = EOK;
@@ -317,5 +317,5 @@
 			break;
 
-		case USB_HUB_FEATURE_PORT_SUSPEND:
+		case USB2_HUB_FEATURE_PORT_SUSPEND:
 			if (port_state == HUB_PORT_STATE_ENABLED) {
 				hub_set_port_state(hub, port, HUB_PORT_STATE_SUSPENDED);
Index: uspace/drv/bus/usb/vhc/main.c
===================================================================
--- uspace/drv/bus/usb/vhc/main.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/vhc/main.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -40,4 +40,5 @@
 
 #include <usb/host/ddf_helpers.h>
+#include <usb/host/utility.h>
 
 #include <usb/debug.h>
@@ -69,39 +70,33 @@
 		return ret;
 	}
-	vhc_init(vhc);
 	return EOK;
 }
 
-hcd_ops_t vhc_hc_ops = {
-	.schedule = vhc_schedule,
-};
-
 static errno_t vhc_dev_add(ddf_dev_t *dev)
 {
+	/* Initialize generic structures */
+	errno_t ret = hcd_ddf_setup_hc(dev, sizeof(vhc_data_t));
+	if (ret != EOK) {
+		usb_log_error("Failed to init HCD structures: %s.",
+		   str_error(ret));
+		return ret;
+	}
+	vhc_data_t *vhc = ddf_dev_data_get(dev);
+	vhc_init(vhc);
+
+	hc_device_setup(&vhc->base, (bus_t *) &vhc->bus);
+
 	/* Initialize virtual structure */
 	ddf_fun_t *ctl_fun = NULL;
-	errno_t ret = vhc_control_node(dev, &ctl_fun);
+	ret = vhc_control_node(dev, &ctl_fun);
 	if (ret != EOK) {
-		usb_log_error("Failed to setup control node.\n");
-		return ret;
-	}
-	vhc_data_t *data = ddf_fun_data_get(ctl_fun);
-
-	/* Initialize generic structures */
-	ret = hcd_ddf_setup_hc(dev, USB_SPEED_FULL,
-	    BANDWIDTH_AVAILABLE_USB11, bandwidth_count_usb11);
-	if (ret != EOK) {
-		usb_log_error("Failed to init HCD structures: %s.\n",
-		   str_error(ret));
-		ddf_fun_destroy(ctl_fun);
+		usb_log_error("Failed to setup control node.");
 		return ret;
 	}
 
-	hcd_set_implementation(dev_to_hcd(dev), data, &vhc_hc_ops);
-
 	/* Add virtual hub device */
-	ret = vhc_virtdev_plug_hub(data, &data->hub, NULL, 0);
+	ret = vhc_virtdev_plug_hub(vhc, &vhc->hub, NULL, 0);
 	if (ret != EOK) {
-		usb_log_error("Failed to plug root hub: %s.\n", str_error(ret));
+		usb_log_error("Failed to plug root hub: %s.", str_error(ret));
 		ddf_fun_destroy(ctl_fun);
 		return ret;
@@ -112,7 +107,7 @@
 	 * needs to be ready at this time.
 	 */
-	ret = hcd_ddf_setup_root_hub(dev);
+	ret = hc_setup_virtual_root_hub(&vhc->base, USB_SPEED_HIGH);
 	if (ret != EOK) {
-		usb_log_error("Failed to init VHC root hub: %s\n",
+		usb_log_error("Failed to init VHC root hub: %s",
 			str_error(ret));
 		// TODO do something here...
Index: uspace/drv/bus/usb/vhc/transfer.c
===================================================================
--- uspace/drv/bus/usb/vhc/transfer.c	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/vhc/transfer.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -31,4 +31,7 @@
 #include <usb/debug.h>
 #include <usbvirt/device.h>
+#include <usb/host/bandwidth.h>
+#include <usb/host/endpoint.h>
+#include <usb/host/usb_transfer_batch.h>
 #include <usbvirt/ipc.h>
 #include "vhcd.h"
@@ -37,15 +40,15 @@
 static bool is_set_address_transfer(vhc_transfer_t *transfer)
 {
-	if (transfer->batch->ep->endpoint != 0) {
-		return false;
-	}
-	if (transfer->batch->ep->transfer_type != USB_TRANSFER_CONTROL) {
-		return false;
-	}
-	if (usb_transfer_batch_direction(transfer->batch) != USB_DIRECTION_OUT) {
-		return false;
-	}
-	const usb_device_request_setup_packet_t *setup =
-	    (void*)transfer->batch->setup_buffer;
+	if (transfer->batch.target.endpoint != 0) {
+		return false;
+	}
+	if (transfer->batch.ep->transfer_type != USB_TRANSFER_CONTROL) {
+		return false;
+	}
+	if (transfer->batch.dir != USB_DIRECTION_OUT) {
+		return false;
+	}
+	const usb_device_request_setup_packet_t *setup
+		= &transfer->batch.setup.packet;
 	if (setup->request_type != 0) {
 		return false;
@@ -62,11 +65,11 @@
 {
 	errno_t rc;
-	
-	const usb_direction_t dir = usb_transfer_batch_direction(batch);
+
+	const usb_direction_t dir = batch->dir;
 
 	if (batch->ep->transfer_type == USB_TRANSFER_CONTROL) {
 		if (dir == USB_DIRECTION_IN) {
 			rc = usbvirt_control_read(dev,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size,
 			    actual_data_size);
@@ -74,5 +77,5 @@
 			assert(dir == USB_DIRECTION_OUT);
 			rc = usbvirt_control_write(dev,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size);
 		}
@@ -99,10 +102,10 @@
 	errno_t rc;
 
-	const usb_direction_t dir = usb_transfer_batch_direction(batch);
+	const usb_direction_t dir = batch->dir;
 
 	if (batch->ep->transfer_type == USB_TRANSFER_CONTROL) {
 		if (dir == USB_DIRECTION_IN) {
 			rc = usbvirt_ipc_send_control_read(sess,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size,
 			    actual_data_size);
@@ -110,5 +113,5 @@
 			assert(dir == USB_DIRECTION_OUT);
 			rc = usbvirt_ipc_send_control_write(sess,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size);
 		}
@@ -147,10 +150,45 @@
 	assert(outcome != ENAK);
 	assert(transfer);
-	assert(transfer->batch);
-	usb_transfer_batch_finish_error(transfer->batch, NULL,
-	    data_transfer_size, outcome);
-	usb_transfer_batch_destroy(transfer->batch);
-	free(transfer);
-}
+	transfer->batch.error = outcome;
+	transfer->batch.transferred_size = data_transfer_size;
+	usb_transfer_batch_finish(&transfer->batch);
+}
+
+static usb_transfer_batch_t *batch_create(endpoint_t *ep)
+{
+	vhc_transfer_t *transfer = calloc(1, sizeof(vhc_transfer_t));
+	usb_transfer_batch_init(&transfer->batch, ep);
+	link_initialize(&transfer->link);
+	return &transfer->batch;
+}
+
+static int device_enumerate(device_t *device)
+{
+	vhc_data_t *vhc = bus_to_vhc(device->bus);
+	return usb2_bus_device_enumerate(&vhc->bus_helper, device);
+}
+
+static int endpoint_register(endpoint_t *endpoint)
+{
+	vhc_data_t *vhc = bus_to_vhc(endpoint->device->bus);
+	return usb2_bus_endpoint_register(&vhc->bus_helper, endpoint);
+}
+
+static void endpoint_unregister(endpoint_t *endpoint)
+{
+	vhc_data_t *vhc = bus_to_vhc(endpoint->device->bus);
+	usb2_bus_endpoint_unregister(&vhc->bus_helper, endpoint);
+
+	// TODO: abort transfer?
+}
+
+static const bus_ops_t vhc_bus_ops = {
+	.batch_create = batch_create,
+	.batch_schedule = vhc_schedule,
+
+	.device_enumerate = device_enumerate,
+	.endpoint_register = endpoint_register,
+	.endpoint_unregister = endpoint_unregister,
+};
 
 errno_t vhc_init(vhc_data_t *instance)
@@ -159,20 +197,16 @@
 	list_initialize(&instance->devices);
 	fibril_mutex_initialize(&instance->guard);
-	instance->magic = 0xDEADBEEF;
+	bus_init(&instance->bus, sizeof(device_t));
+	usb2_bus_helper_init(&instance->bus_helper, &bandwidth_accounting_usb11);
+	instance->bus.ops = &vhc_bus_ops;
 	return virthub_init(&instance->hub, "root hub");
 }
 
-errno_t vhc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch)
-{
-	assert(hcd);
+errno_t vhc_schedule(usb_transfer_batch_t *batch)
+{
 	assert(batch);
-	vhc_data_t *vhc = hcd_get_driver_data(hcd);
+	vhc_transfer_t *transfer = (vhc_transfer_t *) batch;
+	vhc_data_t *vhc = bus_to_vhc(endpoint_get_bus(batch->ep));
 	assert(vhc);
-
-	vhc_transfer_t *transfer = malloc(sizeof(vhc_transfer_t));
-	if (!transfer)
-		return ENOMEM;
-	link_initialize(&transfer->link);
-	transfer->batch = batch;
 
 	fibril_mutex_lock(&vhc->guard);
@@ -182,5 +216,5 @@
 	list_foreach(vhc->devices, link, vhc_virtdev_t, dev) {
 		fibril_mutex_lock(&dev->guard);
-		if (dev->address == transfer->batch->ep->address) {
+		if (dev->address == transfer->batch.target.address) {
 			if (!targets) {
 				list_append(&transfer->link, &dev->transfer_queue);
@@ -194,5 +228,5 @@
 	
 	if (targets > 1)
-		usb_log_warning("Transfer would be accepted by more devices!\n");
+		usb_log_warning("Transfer would be accepted by more devices!");
 
 	return targets ? EOK : ENOENT;
@@ -217,15 +251,15 @@
 		size_t data_transfer_size = 0;
 		if (dev->dev_sess) {
-			rc = process_transfer_remote(transfer->batch,
+			rc = process_transfer_remote(&transfer->batch,
 			    dev->dev_sess, &data_transfer_size);
 		} else if (dev->dev_local != NULL) {
-			rc = process_transfer_local(transfer->batch,
+			rc = process_transfer_local(&transfer->batch,
 			    dev->dev_local, &data_transfer_size);
 		} else {
-			usb_log_warning("Device has no remote phone nor local node.\n");
+			usb_log_warning("Device has no remote phone nor local node.");
 			rc = ESTALL;
 		}
 
-		usb_log_debug2("Transfer %p processed: %s.\n",
+		usb_log_debug2("Transfer %p processed: %s.",
 		    transfer, str_error(rc));
 
@@ -234,7 +268,7 @@
 			if (is_set_address_transfer(transfer)) {
 				usb_device_request_setup_packet_t *setup =
-				    (void*) transfer->batch->setup_buffer;
+				    (void*) transfer->batch.setup.buffer;
 				dev->address = setup->value;
-				usb_log_debug2("Address changed to %d\n",
+				usb_log_debug2("Address changed to %d",
 				    dev->address);
 			}
Index: uspace/drv/bus/usb/vhc/vhcd.h
===================================================================
--- uspace/drv/bus/usb/vhc/vhcd.h	(revision 2752620b090f5bf0ecc3baace21dc1fa5da89d73)
+++ uspace/drv/bus/usb/vhc/vhcd.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -38,8 +38,10 @@
 
 #include <usbvirt/device.h>
-#include <usbhc_iface.h>
 #include <async.h>
+#include <macros.h>
 
 #include <usb/host/hcd.h>
+#include <usb/host/usb2_bus.h>
+#include <usb/host/usb_transfer_batch.h>
 
 #define NAME "vhc"
@@ -56,5 +58,10 @@
 
 typedef struct {
-	uint32_t magic;
+	hc_device_t base;
+
+	bus_t bus;
+	usb2_bus_helper_t bus_helper;
+
+	ddf_fun_t *virtual_fun;
 	list_t devices;
 	fibril_mutex_t guard;
@@ -63,7 +70,19 @@
 
 typedef struct {
+	usb_transfer_batch_t batch;
 	link_t link;
-	usb_transfer_batch_t *batch;
 } vhc_transfer_t;
+
+static inline vhc_data_t *hcd_to_vhc(hc_device_t *hcd)
+{
+	assert(hcd);
+	return (vhc_data_t *) hcd;
+}
+
+static inline vhc_data_t *bus_to_vhc(bus_t *bus)
+{
+	assert(bus);
+	return member_to_inst(bus, vhc_data_t, bus);
+}
 
 void on_client_close(ddf_fun_t *fun);
@@ -76,6 +95,6 @@
 void vhc_virtdev_unplug(vhc_data_t *, uintptr_t);
 
-errno_t vhc_init(vhc_data_t *instance);
-errno_t vhc_schedule(hcd_t *hcd, usb_transfer_batch_t *batch);
+errno_t vhc_init(vhc_data_t *);
+errno_t vhc_schedule(usb_transfer_batch_t *);
 errno_t vhc_transfer_queue_processor(void *arg);
 
Index: uspace/drv/bus/usb/xhci/Makefile
===================================================================
--- uspace/drv/bus/usb/xhci/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/xhci/Makefile	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,53 @@
+#
+# Copyright (c) 2017 Ondrej Hlavaty <aearsis@eideo.cz>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../../..
+
+LIBS = usbhost usbvirt usb drv
+
+BINARY = xhci
+
+SOURCES = \
+	bus.c \
+	commands.c \
+	debug.c \
+	device.c \
+	endpoint.c \
+	hc.c \
+	isoch.c \
+	main.c \
+	rh.c \
+	scratchpad.c \
+	streams.c \
+	transfers.c \
+	trb_ring.c
+
+TEST_SOURCES = \
+	test/reg-ops.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/drv/bus/usb/xhci/bus.c
===================================================================
--- uspace/drv/bus/usb/xhci/bus.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/xhci/bus.c	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,97 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty <aearsis@eideo.cz>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/**  @addtogroup libusbhost
+ * @{
+ */
+/** @file
+ * xHCI bus interface.
+ */
+
+#include <usb/descriptor.h>
+
+#include "hc.h"
+#include "device.h"
+#include "endpoint.h"
+#include "transfers.h"
+
+#include "bus.h"
+
+
+static const bus_ops_t xhci_bus_ops = {
+	.interrupt = hc_interrupt,
+	.status = hc_status,
+
+	.device_enumerate = xhci_device_enumerate,
+	.device_gone = xhci_device_gone,
+	.device_online = xhci_device_online,
+	.device_offline = xhci_device_offline,
+
+	.endpoint_create = xhci_endpoint_create,
+	.endpoint_destroy = xhci_endpoint_destroy,
+	.endpoint_register = xhci_endpoint_register,
+	.endpoint_unregister = xhci_endpoint_unregister,
+
+	.batch_schedule = xhci_transfer_schedule,
+	.batch_create = xhci_transfer_create,
+	.batch_destroy = xhci_transfer_destroy,
+};
+
+/** Initialize XHCI bus.
+ * @param[in] bus Allocated XHCI bus to initialize.
+ * @param[in] hc Associated host controller, which manages the bus.
+ *
+ * @return Error code.
+ */
+int xhci_bus_init(xhci_bus_t *bus, xhci_hc_t *hc)
+{
+	assert(bus);
+
+	bus_init(&bus->base, sizeof(xhci_device_t));
+
+	bus->devices_by_slot = calloc(hc->max_slots, sizeof(xhci_device_t *));
+	if (!bus->devices_by_slot)
+		return ENOMEM;
+
+	bus->hc = hc;
+	bus->base.ops = &xhci_bus_ops;
+	return EOK;
+}
+
+/** Finalize XHCI bus.
+ * @param[in] bus XHCI bus to finalize.
+ */
+void xhci_bus_fini(xhci_bus_t *bus)
+{
+	// FIXME: Ensure there are no more devices?
+	free(bus->devices_by_slot);
+	// FIXME: Something else we forgot?
+}
+
+/**
+ * @}
+ */
Index: uspace/drv/bus/usb/xhci/bus.h
===================================================================
--- uspace/drv/bus/usb/xhci/bus.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
+++ uspace/drv/bus/usb/xhci/bus.h	(revision 2b3dd78e52704a51e22b71513327373cf8f6a614)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty <aearsis@eideo.cz>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/** @addtogroup libusbhost
+ * @{
+ */
+/** @file
+ *
+ * An implementation of bus keeper for xHCI. The (physical) HC itself takes
+ * care about addressing devices, so this implementation is actually simpler
+ * than those of [OUE]HCI.
+ */
+#ifndef XHCI_BUS_H
+#define XHCI_BUS_H
+
+#include <usb/host/bus.h>
+
+typedef struct xhci_hc xhci_hc_t;
+typedef struct xhci_device xhci_device_t;
+
+/** Endpoint management structure */
+typedef struct xhci_bus {
+	bus_t base;		/**< Inheritance. Keep this first. */
+
+	xhci_hc_t *hc;				/**< Pointer to managing HC (to issue commands) */
+
+	xhci_device_t **devices_by_slot;	/**< Devices by Slot ID */
+} xhci_bus_t;
+
+extern int xhci_bus_init(xhci_bus_t *, xhci_hc_t *);
+extern void xhci_bus_fini(xhci_bus_t *);
+
+static inline xhci_bus_t *bus_to_xhci_bus(bus_t *bus_base)
+{
+	assert(bus_base);
+	return (xhci_bus_t *) bus_base;
+}
+
+#endif
+/**
+ * @}
+ */
